﻿using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

namespace EFCoreEnumsMapping
{
    public partial class EfCoreEnumsMappingDbContext : DbContext
    {
        public EfCoreEnumsMappingDbContext()
        {
        }

        public EfCoreEnumsMappingDbContext(DbContextOptions<EfCoreEnumsMappingDbContext> options)
            : base(options)
        {
        }

        public virtual DbSet<Address> Address { get; set; }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (!optionsBuilder.IsConfigured)
            {
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. See http://go.microsoft.com/fwlink/?LinkId=723263 for guidance on storing connection strings.
                //optionsBuilder.UseSqlServer("Data Source='(LocalDB)\\MSSQLLocalDB';Integrated Security=True;Pooling=False;Initial Catalog='EFCoreEnumsMappingDb'");
            }
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Address>(entity =>
            {
                entity.Property(e => e.AddressId).ValueGeneratedOnAdd();

                entity.Property(e => e.Line1)
                    .IsRequired()
                    .HasMaxLength(50)
                    .IsUnicode(false);

                entity.Property(e => e.Line2)
                    .IsRequired()
                    .HasMaxLength(50)
                    .IsUnicode(false);

                entity.Property(e => e.AddressType)
                    .HasConversion(x => (int) x, x => (AddressType) x);

                entity.Property(e => e.DeliveryPreference)
                    .HasMaxLength(50)
                    .HasConversion(x => x.ToString(),
                        x => (DeliveryPreference) Enum.Parse(typeof(DeliveryPreference), x));

            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}
